; Eratosthenes' first demo - add some code to play with the logo!

.init_vf_all
.init_vi_all
.syntax new

.vu

kStarsStart .assign 85 ; Now you see why the memory map comes in useful :)
kStarsEnd .assign 485

--enter
--endenter

START:
	iaddiu iPointer, vi00, kStarsStart ; Initialise iPointer
	iaddiu iEndPointer, vi00, kStarsEnd ; Initialise iEndPointer
STARSLOOP:
	iaddiu iPointer, iPointer, 2  ; Move onto the (first|next) vertex XYZ data
	ilw.x iX, 0(iPointer) ; Load iPointer[x] into iX
	ilw.z iZ, 0(iPointer) ; Load iPointer[z] into iZ
	iadd iX, iX, iZ       ; iX = iX + iZ
	isubiu iCheck, iX, 27888
	isubiu iCheck, iCheck, 10000
	ibgtz iCheck, WRAP:   ; if (iX - 27888 - 10000 > 0) <Right edge of screen> goto WRAP
WRAPDONE:
	isw.x iX, 0(iPointer) ; Store iX into iPointer[x]
	ibne iPointer, iEndPointer, STARSLOOP  ; Restart the loop if we're not at the end yet
	b KICK:
WRAP:
	iaddiu iX, vi00, 27648 ; iX = 27648 <Left edge of screen>.
	b WRAPDONE:
KICK:
	xgkick vi00 ; Send the whole GIFtag off (Logo and Starfield)

--exit
--endexit

.END
